﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using m2jz;

namespace TestJZ
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string version;
	        uint major, minor, revision, bild;	


            major = minor =  revision = bild = 0;	

	        if(mjz.mjzGetFileVersion(	"mgc2jz.dll", 
							            ref major,
							            ref minor, 
							            ref revision,
							            ref bild	) == mjz.SUCCESS)
	        {
		        version = string.Format(    "JZ DLL VERSION {0:d}.{1:d}.{2:d}.{3:d}",
                                            major, 
                                            minor,
                                            revision, 
                                            bild    );
		        labelVersion.Text = version;
	        }
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            // 加算
	        // ・加算します。
	        // ・障害時は 0xffff0000 - 0xffffffff を返す。正常終了なら配列の要素数。
	        //   すなわち配列の最大要素数は 0xfffeffff である。
	        // ・配列の先頭は符号を表す。１ならマイナス、０ならプラス
	        // ・各配列の最大桁数は１０進数で９とする。すなわち最大数は 999,999,999 である。
            uint figures;
	        uint result;
            bool correct;
            const uint na = 25;
		    const uint nb = 20;
		
	        uint [] da = {  mjz.POSITIVE,
						    mjz.RESERVED,
						    528549889, 748512565, 987458245, 628598789, 897979897, 564528549, 
						    889748512, 500659528, 549889748, 512565987, 458245628, 598789897,
						    979897564, 528549889, 748512500, 659528549, 889748512, 565987458, 
						    245628598, 789897979, 897564528, 549889748, 512500659	};
		    uint [] db = {  mjz.POSITIVE,
						    mjz.RESERVED,
						          989, 797989756, 452854988, 974851250,  65987458, 245628598,
						    789898979, 798975645, 285498897, 485125006, 598745824, 562859878,
						    989897979, 897564528, 549889748, 512500659, 874582456, 285987898 };
		    uint [] dc = new uint[na];
		    // answer
		    uint [] ac = {  mjz.POSITIVE,
			    			mjz.RESERVED,
				    		528549889, 748512565, 987458245, 628598789, 897979897, 564529539,
					    	687738268, 953514517, 524740998, 578553445, 703874227, 388688877,
						    778873209, 814048787, 233637507, 258274374, 452608391, 555885438,
						    143193127, 339787728, 410065188, 424472204, 798488557 };
            // 時間の計測
            Stopwatch sw = new Stopwatch();
            sw.Start();

            da.CopyTo(dc, 0);
			
		    // 桁数が指定値より小さいかを診断する。すべて正しければ配列の最大要素数を返す。
		    figures = mjz.mjzCheckForFigures(dc, na, 9);
		    result  = mjz.mjzAdd(dc, na, db, nb);
		    // ふたつの配列値が同じであることを診断する。すべて正しければ TRUE を返す。
		    correct = mjz.mjzCompare(dc, na, ac, na) == 0;
            sw.Stop();

            SetLabels(correct, ref sw, da, na, db, nb, dc, na);
        }

        private void buttonSubtract_Click(object sender, EventArgs e)
        {
            // 減算
	        // ・減算します。
	        // ・障害時は 0xffff0000 - 0xffffffff を返す。正常終了なら配列の要素数。
	        //   すなわち配列の最大要素数は 0xfffeffff である。
	        // ・配列の先頭は符号を表す。１ならマイナス、０ならプラス
	        // ・各配列の最大桁数は１０進数で９とする。すなわち最大数は 999,999,999 である。
	        bool correct;
	        uint figures;
	        uint result;

            const uint na = 12;
		    const uint nb = 7;
		    const uint nc = na;
		    uint [] da = {  mjz.POSITIVE,	     
						    mjz.RESERVED,
					              137, 458365713, 637165763, 178653661, 865716386, 371657618,
						    653165316, 531653165, 173631651, 375631865 };
		    uint [] db = {  mjz.NEGATIVE,	
						    mjz.RESERVED,
						      716, 576176576, 756125465, 156762175, 156555154 };
		    uint [] dc = new uint[na];
		    uint [] ac = { mjz.POSITIVE,
						    mjz.RESERVED,
						         137, 458365713, 637165763, 178653661,	865716386, 371656902,
						    76988739, 775527700,  16869476, 219076711 };
             // 時間の計測
            Stopwatch sw = new Stopwatch();
            sw.Start();

		    da.CopyTo(dc, 0);

		    figures = mjz.mjzCheckForFigures(da, na, 9);
		    figures = mjz.mjzCheckForFigures(db, nb, 9);
		    result  = mjz.mjzAdd(dc, nc, db, nb);
		    correct = mjz.mjzCompare(dc, na, ac, na) == 0;

            sw.Stop();

		    SetLabels(correct, ref sw, da, na, db, nb, dc, result);
        }

        private void buttonMultiply_Click(object sender, EventArgs e)
        {
            // 乗算
	        // ・乗算します。
	        // ・障害時は 0xffff0000 - 0xffffffff を返す。正常終了なら配列の要素数。
	        //   すなわち配列の最大要素数は 0xfffeffff である。
	        // ・配列の最後は符号を表す。１ならマイナス、０ならプラス
	        // ・乗数と被乗数の配列の要素数は異なっても構わない
	        // ・各配列の最大桁数は１０進数で９とする。すなわち最大数は 999,999,999 である。
		    bool correct;
	        uint figures;
	        uint result;

            const uint na = 12;
		    const uint nb = 4;
		    const uint nc = na + nb;
		    uint [] da = { mjz.POSITIVE,	
						    mjz.RESERVED,
					        123456787, 654345678,  98764321,      654, 321876543, 210099987,
					        654328890, 346543219, 876547820, 987654321 };
		    uint [] db = { mjz.POSITIVE,
						    mjz.RESERVED,
					                7, 
					        582918690 };
		    uint [] dc = new uint[nc];
		    uint [] ac = {  mjz.POSITIVE,
						    mjz.RESERVED,
						    936162782, 511499102, 175843635, 616064451, 669586915, 380459793,
						    152779802,  15763158, 894653964, 446058209, 970159490 };
             // 時間の計測
            Stopwatch sw = new Stopwatch();
            sw.Start();

		    figures = mjz.mjzCheckForFigures(da, na, 9);
		    figures = mjz.mjzCheckForFigures(db, nb, 9);
		    result  = mjz.mjzMultiply(da, na, db, nb, dc, nc);
		    result = mjz.mjzCheckForZero(dc, nc);
		    result = mjz.mjzShiftToLeft(dc, nc, result - mjz.NUMERICAL_POINTER);

		    correct = mjz.mjzCompare(dc, result, ac, result) == 0;
            sw.Stop();

		    SetLabels(correct, ref sw, da, na, db, nb, dc, result);
        }

        private void buttonDivide_Click(object sender, EventArgs e)
        {
            // 除算
	        // ・除算します。
	        // ・障害時は 0xffff0000 - 0xffffffff を返す。正常終了なら配列の要素数。
	        //   すなわち配列の最大要素数は 0xfffeffff である。
	        // ・配列の先頭は符号を表す。１ならマイナス、０ならプラス
	        // ・除数と被除数の配列の要素数は異なっても構わない
	        // ・各配列の最大桁数は１０進数で９とする。すなわち最大数は 999,999,999 である。
	        // ・第５引数が商、第１引数が余りとなる
	        bool correct;
	        uint result;

            const uint na = 12;
		    const uint nb = 5;
		    const uint nq = 12;
		    uint [] da = { mjz.POSITIVE,  
			                mjz.RESERVED,
					        76, 324089682, 448756762, 0, 0, 0, 0, 0, 0, 0 };
		    uint [] db = {  mjz.POSITIVE,   
			    			mjz.RESERVED,
				    		24, 294712299, 901695663  };
		    uint [] ac = {  mjz.POSITIVE, 
			    			mjz.RESERVED,
				    		        0,         0,         3, 141592653, 589793238, 462643383,
					    	279502884, 134204314, 768296341, 347735847	};
		    uint [] quotient = new uint[nq];
		    uint [] remainder = new uint[na];	// Remainder = 18, 665538574, 110309818

		    // PI = 3
		    //      141592653	
		    //      589793238
		    //      462643383
		    //      279502884
		    //      197169399
             // 時間の計測
            Stopwatch sw = new Stopwatch();
            sw.Start();

            da.CopyTo(remainder, 0);
	
		    result  = mjz.mjzDivide(remainder, na, db, nb, quotient, nq);
		    correct = mjz.mjzCompare(quotient, nq, ac, nq) == 0;

            sw.Stop();

		    SetLabels(correct, ref sw, da, na, db, nb, quotient, result, remainder, na);
        }

        private void buttonFactorial_Click(object sender, EventArgs e)
        {
            // 階乗の計算
	        // ・スターリングの近似式　n! = n^n * e^-n * (2*n*pi)^(1/2)
	        bool correct;
	        uint result = 0;

            const int n = 180;
		    const uint nac = 39;

		    uint [] da = {	mjz.POSITIVE, 
						    mjz.RESERVED,
						    n	};
		    uint [] db, dd, dt;
		    uint [] c = {   mjz.POSITIVE, 
						    mjz.RESERVED,
						    2	};
		    uint [] ac = {  mjz.POSITIVE, 
						    mjz.RESERVED,
						       200896,  62499134, 299656951, 336898466, 838917540, 340798867, 
						    777940435, 335160044, 860953395, 980941180, 138112097, 309735631,
						    594101037, 399609671,  32132186, 331495273, 609598531, 966730972,
						    945653558, 819806475,  64353856, 858157445,  40809209, 560358463,
						    319644664, 891114256, 430017824, 141796753, 818192338, 642302693,
						    327818731, 986039603, 200000000,         0,         0,         0,
						    0 };
		    uint figures;
		    uint size;
            // 時間の計測
            Stopwatch sw = new Stopwatch();
            sw.Start();


		    // 桁数の予想
		    // スターリングの近似式より
		    figures = (uint)(n * Math.Log10(n * 0.3678794411714) + 0.5 * Math.Log10(2.0 * Math.PI) + 1);
		    size = figures / mjz.SIGNIFICANT_FIGURES + 1 + mjz.NUMERICAL_POINTER;

		    db = new uint[size];
		    dd = new uint[size];
		    db[size - 1] = 1;

		    for(uint i = 0; i < n; i++)
		    {
			    result = mjz.mjzMultiply(db, size, c, 3, dd, size);
			
			    dt = dd;
			    dd = db;
			    db = dt;

			    c[mjz.NUMERICAL_POINTER] ++;
		    }

		    correct = mjz.mjzCompare(dd, result, ac, nac) == 0;

            sw.Stop();

		    SetLabels(correct, ref sw, da, 3, dd, result);
        }

        private void buttonLogarithm_Click(object sender, EventArgs e)
        {
            // 対数
	        // ・logX = 1/X の面積
	        // ・積分に台形公式使用 logX = h/2 * (1/1+1/Xn+2*(1/X1+1/X2....1/Xn-1))
		    uint result;
	    
            // log3.1 = 1.131402111491100561911172869858
	        const uint n  = 12; 
	        const uint nf = 5; 
	        const uint nh = 5; 
	        const uint ni = 3; 
	        const uint ns = 24; 
	
	        uint [] f0 = {  mjz.POSITIVE,
			    	    	mjz.RESERVED,
				    	    0, 1, 0, 0, 0, 0, 0, 0, 0, 0 };
	        uint [] fn = {  mjz.POSITIVE,
			        		mjz.RESERVED,
					        0, 3, 100000000 };
	        uint [] h  = { mjz.POSITIVE,
			        		mjz.RESERVED,
					        0, 0, 21000000 };
	        uint [] s  = new uint[ns];
	        uint [] s0 = new uint[n], s1 = new uint[n], s2 = new uint[n], sn = new uint[n];
	        uint [] ta = new uint[n], tb = new uint[n], tc = new uint[n];
	        uint [] i  = new uint[ni];
            // 時間の計測
            Stopwatch sw = new Stopwatch();
            sw.Start();

	        ta[mjz.NUMERICAL_POINTER] = 1;
	        result = mjz.mjzDivide(ta, n, fn, nf, s0, n);
	        result = mjz.mjzAdd(s0, n, f0, n);

	        tb[mjz.NUMERICAL_POINTER + 1] = 1;

	        for( i[mjz.NUMERICAL_POINTER] = 1; 
		         i[mjz.NUMERICAL_POINTER] < 100;
		         i[mjz.NUMERICAL_POINTER]++ )
	        {
                Array.Clear(ta, 0, (int)n);
                Array.Clear(tc, 0, (int)n);
		        tc[mjz.NUMERICAL_POINTER] = 1;

		        result = mjz.mjzMultiply(i, ni, h, nh, ta, 5);
		        result = mjz.mjzAdd(ta, result, tb, result);
		        result = mjz.mjzDivide(tc, n, ta, result, sn, n);
		        result = mjz.mjzAdd(s1, n, sn, n);
	        }

            Array.Clear(ta, 0, (int)n);
            Array.Clear(tb, 0, (int)n);

		    ta[n - 1] = 2; 
	        result = mjz.mjzMultiply(s1, n, ta, n, s2, n);
	        result = mjz.mjzAdd(s2, n, s0, n);
	        ta[mjz.NUMERICAL_POINTER] = 2; 
	        result = mjz.mjzDivide(h, nh, ta, 3, tb, nh);
	        result = mjz.mjzMultiply(s2, n, tb, result, s, n + 1);

            sw.Stop();

	        SetLabels(true, ref sw, fn, nf, s, result);
        }

        private void buttonPower_Click(object sender, EventArgs e)
        {
            // 冪乗
	   		const int na	= 32;
		    int power	    = 102;
		    uint [] answer  = new uint[na];
		    uint [] baseForPower   = { mjz.POSITIVE,
							    mjz.RESERVED, 39 };
		    uint [] p		= { mjz.POSITIVE,
							    mjz.RESERVED, (uint)power };
		    uint [] ac		= { mjz.POSITIVE,
							    mjz.RESERVED,
							            1, 943524039,  63826536, 649857299, 724357504, 709860298, 
							    384642872, 517237682, 989751006, 104182243, 343398736, 298811722, 
							    231536565, 749131513,  96597373, 810943242, 880339240, 987952031,
							    963437521 };
	
		    bool correct = false ;
		    uint result;
             // 時間の計測
            Stopwatch sw = new Stopwatch();
            sw.Start();
		
	
		    result = mjz.mjzPower(baseForPower, 3, power, answer, na);

		    if(result < mjz.MAX_SIZE_OF_ELEMENTS)
		    {
			    result = mjz.mjzShiftToLeft(	answer,
									        na,
									        mjz.mjzCheckForZero(answer, na) - mjz.NUMERICAL_POINTER);
			    correct = mjz.mjzCompare(answer, result, ac, result) == 0;
		    }

            sw.Stop();

		    SetLabels(correct, ref sw, baseForPower, 3, p, 3, answer, result);
        }

        private void buttonSquareRoot_Click(object sender, EventArgs e)
        {
            // 平方根 
	        //	・平方根を求める
	        //	・ニュートン法を使用
	        //	・y = x^2 - a より 0 = (x + a / x) / 2 を算出 
	        const uint n    = 12;
	        const uint ne   = 24;
	        const uint n2	= 3;
	        const uint nac  = 6;

	        bool correct;
	        uint [] da = new uint[n];
	        uint [] dc = new uint[n];
	        uint [] dq = new uint[n];
	        uint [] de = new uint[ne];
	        uint result;

            // square root of 99
		    uint [] initialValue = { 9, 000000000 };
		    uint [] target	     = { mjz.POSITIVE,	
							   	     mjz.RESERVED,
								     99, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
		    uint [] ac			 = { mjz.POSITIVE,
							  	     mjz.RESERVED,
								     9, 949874371, 66199547, 344798210, 121 };
		    uint [] errorRange  = { mjz.POSITIVE,	
							  	    mjz.RESERVED,
								            0,         0,         0,         0,         0, 999999999, 
								    999999999, 999999999, 999999999, 999999999 };
		    uint [] d2 = {	mjz.POSITIVE,	
			    			mjz.RESERVED,
				    		2 };
             // 時間の計測
            Stopwatch sw = new Stopwatch();
            sw.Start();

            Array.Clear(dc, 0, dc.Length);
            initialValue.CopyTo(dc, 2);

		    for(uint i = 0; i < 10; i++)
		    {
                target.CopyTo(da, 0);
		
			    result = mjz.mjzDivide(da, n, dc, n, dq, n);
                result = mjz.mjzRemoveZero(dq, n);
                dc.CopyTo(da, 0);
                result = mjz.mjzRemoveZero(da, n);
			    result = mjz.mjzAdd(dq, n, da, n);
			    result = mjz.mjzDivide(dq, n, d2, n2, dc, n);

			    // 判定
			    result  = mjz.mjzMultiply(dc, n, dc, n, de, ne);
			    de[mjz.SIGN_POINTER] = mjz.NEGATIVE;
                result = mjz.mjzRemoveZero(de, ne);
                result = mjz.mjzAdd(de, n, target, n);
			    de[mjz.SIGN_POINTER] = mjz.POSITIVE;

			    if(mjz.mjzCompare(de, n, errorRange, n) < 0)
				    break;

    			result  = mjz.mjzShiftToRight(dc, n, 4);
	    	}
            
            result = mjz.mjzRemoveZero(dc, n);
		    correct = mjz.mjzCompare(dc, nac, dc, nac) == 0;

            sw.Stop();

		    SetLabels(correct, ref sw, target, n, dc, n);
        }


        private void SetLabel(int id, uint [] a, uint na)
        {
	        string [] title = {	"A = ", 
						        "B = ",
                                "ANSWER = ",
						        "REMAINDER = " };
	        string [] space = { "        ",
							    "        ",
							    "                  ",
							    "                       "  };
	        string text = "";
	        string tmp0 = "";
	        
	        if(na == 0)
	        {
		        text = title[id]; 
	        }
	        else
	        {
		        for(uint i = 0; i < na; i++)
		        {
			        switch(i)
			        {
			        case mjz.SIGN_POINTER:
				        tmp0 = title[id];
				        if(na > 1)
					        tmp0 += (a[i] == 0)? "+ " : "- ";
				        break;
			        case mjz.RESERVED_POINTER:
				        tmp0 = "";
				        break;
			        case mjz.NUMERICAL_POINTER:
				        tmp0 = string.Format("{0:d9}\n", a[i]);
				        break;
			        default:
				        tmp0 = string.Format("{0:s}{1:d9}\n", space[id], a[i]);
				        break;
			        }

			        text += tmp0;
		        }
	        }

	        switch(id)
	        {
	        case 0:
		        labelA.Text = text;
		        break;
	        case 1:
		        labelB.Text = text;
		        break;
	        case 2:
		        labelAnswer.Text = text;
		        break;
	        case 3:
		        labelRemainder.Text = text;
		        break;
	        }
        }

        private void SetLabels(bool correct, ref Stopwatch sw, uint [] a, uint na, uint [] c, uint nc)
        {
            uint [] b = { 0 };
            uint [] remainder = { 0 };


	        labelCorrect.Text = string.Format("CORRECT = {0:d}", correct);
	        labelResult.Text = string.Format("RESULT = 0x{0:x8}", nc);
            labelElapsedTime.Text = string.Format(  "ELAPSED TIME = {0:d}.{1:d3} seconds", 
                                                    sw.Elapsed.Seconds,
                                                    sw.Elapsed.Milliseconds);

	        if(nc >= mjz.ERR_MIN_SIZE)
	        {
		        nc = 0;
	        }
	
	        SetLabel(0, a, na);
	        SetLabel(1, b, 0);
	        SetLabel(2, c, nc);
	        SetLabel(3, remainder, 0);	
        }

        private void SetLabels( bool correct, 
                            ref Stopwatch sw,
                                uint [] a, 
                                uint na,
                                uint [] b,
                                uint nb,
                                uint [] c,
                                uint nc )
        {
            SetLabels(correct, ref sw, a, na, c, nc); 
	        SetLabel(1, b, nb);	
        }

        private void SetLabels(	bool  correct,
                                ref Stopwatch sw,
		    				    uint [] a,
			    				uint na, 
				    			uint [] b, 
					    		uint nb,
						    	uint [] c,
							    uint nc,
							    uint [] remainder,
							    uint nr	)
        {
	        SetLabels(correct, ref sw, a, na, b, nb, c, nc);
    
            if(nc >= mjz.ERR_MIN_SIZE)
	        {
		        nr = 0;
	        }

	        SetLabel(3, remainder, nr);	
        }
    }
}
