﻿using System;
using System.Runtime.InteropServices;

namespace m2jz
{
	/// <summary>
    /// mgc2jz.dll Ver2.1700a
    /// </summary>
    class mjz
	{
        public const int SUCCESS = 0;
	    public const int FAILURE = -1;
	    public const int YES	 = 1;
	    public const int NO		 = 0;
   
	    public const uint SIGNIFICANT_NUMBER	= 1000000000;	// 有効数
	    public const uint SIGNIFICANT_FIGURES	= 9;			// 有効桁数
	    public const uint MAX_NUMBER			= 999999999;	// 配列要素が使う最大値

	    public const uint MIN_SIZE_OF_ELEMENTS	= 3;
	    public const uint MAX_SIZE_OF_ELEMENTS	= 0xffff0000;
	    public const uint SIGN_POINTER			= 0;
	    public const uint RESERVED_POINTER		= 1;
	    public const uint NUMERICAL_POINTER	    = 2;
	    public const uint NEGATIVE              = 1;
	    public const uint POSITIVE	            = 0; 
	    public const uint RESERVED	            = 0; 

	    // error は 0xffffffff - 0xffff0000 を使う 
	    public const uint ERR_MIN_SIZE			= MAX_SIZE_OF_ELEMENTS;
	    public const uint ERR_BAD_CONDITIONS	= 0xfffffffc;
	    public const uint ERR_INDETERMINATE	    = 0xfffffffd;
	    public const uint ERR_MEMORY			= 0xfffffffe;
	    public const uint ERR_OVERFLOW			= 0xffffffff;


        [DllImport("mgc2jz.dll")]
        public static extern int mjzCompare(uint [] Da, uint Na, uint [] Db, uint Nb);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzAdd(uint [] Da, uint Na, uint [] Db, uint Nb);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzCheckForFigures(uint [] Da, uint Na, uint figures);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzCheckForZero(uint [] Da, uint Na);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzDivide(uint [] Da, uint Na, uint [] Db, uint Nb, uint [] Dc, uint Nc);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzGetFigures(uint [] Da, uint Na);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzMultiply(uint [] Da, uint Na, uint [] Db, uint Nb, uint [] Dc, uint Nc);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzPower(uint [] powerBase, uint Nb, int power, uint [] answer, uint Na);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzRemoveZero(uint[] Da, uint nNa);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzShiftToLeft(uint [] Da, uint Na, uint expression);
        [DllImport("mgc2jz.dll")]
        public static extern uint mjzShiftToRight(uint [] Da, uint Na, uint expression);

        [DllImport("mgc2jz.dll")]
        public static extern int mjzGetFileVersion(	[MarshalAs(UnmanagedType.LPWStr)]string file,
                                                    ref uint major, 
        											ref uint minor,
        											ref uint revision, 
        											ref uint bild		);
   
	}
    
}