﻿Imports System.Diagnostics

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim version As String
        Dim major As UInteger, minor As UInteger, revision As UInteger, bild As UInteger


        major = minor = revision = bild = 0

        If (mjzGetFileVersion("mgc2jz.dll", major, minor, revision, bild) = MJZ_SUCCESS) Then
            version = String.Format("JZ DLL VERSION {0:d}.{1:d}.{2:d}.{3:d}", major, minor, revision, bild)
            labelVersion.Text = version
        End If

    End Sub

    Private Sub buttonAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonAdd.Click
        '// 加算
        '// ・加算します。
        '// ・障害時は 0xffff0000 - 0xffffffff を返す。正常終了なら配列の要素数。
        '//   すなわち配列の最大要素数は 0xfffeffff である。
        '// ・配列の先頭は符号を表す。１ならマイナス、０ならプラス
        '// ・各配列の最大桁数は１０進数で９とする。すなわち最大数は 999,999,999 である。
        Dim figures As UInteger
        Dim result As UInteger
        Dim correct As Boolean

        Const na As UInteger = 25
        Const nb As UInteger = 20

        Dim da() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                528549889, 748512565, 987458245, 628598789, 897979897, 564528549, _
                                889748512, 500659528, 549889748, 512565987, 458245628, 598789897, _
                                979897564, 528549889, 748512500, 659528549, 889748512, 565987458, _
                                245628598, 789897979, 897564528, 549889748, 512500659}
        Dim db() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                      989, 797989756, 452854988, 974851250, 65987458, 245628598, _
                                789898979, 798975645, 285498897, 485125006, 598745824, 562859878, _
                                989897979, 897564528, 549889748, 512500659, 874582456, 285987898}
        Dim dc() As UInteger = New UInteger(na) {}
        '// answer
        Dim ac() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                528549889, 748512565, 987458245, 628598789, 897979897, 564529539, _
                                687738268, 953514517, 524740998, 578553445, 703874227, 388688877, _
                                778873209, 814048787, 233637507, 258274374, 452608391, 555885438, _
                                143193127, 339787728, 410065188, 424472204, 798488557}
        '// 時間の計測
        Dim sw As Stopwatch = New Stopwatch()
        sw.Start()

        da.CopyTo(dc, 0)

        '// 桁数が指定値より小さいかを診断する。すべて正しければ配列の最大要素数を返す。
        figures = mjzCheckForFigures(dc, na, 9)
        result = mjzAdd(dc, na, db, nb)
        '// ふたつの配列値が同じであることを診断する。すべて正しければ TRUE を返す。
        correct = mjzCompare(dc, na, ac, na) = 0

        sw.Stop()

        SetLabels(correct, sw, da, na, db, nb, dc, na)
    End Sub

    Private Sub buttonSubtract_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSubtract.Click
        '// 減算
        '// ・減算します。
        '// ・障害時は 0xffff0000 - 0xffffffff を返す。正常終了なら配列の要素数。
        '//   すなわち配列の最大要素数は 0xfffeffff である。
        '// ・配列の先頭は符号を表す。１ならマイナス、０ならプラス
        '// ・各配列の最大桁数は１０進数で９とする。すなわち最大数は 999,999,999 である。
        Dim correct As Boolean
        Dim figures As UInteger
        Dim result As UInteger

        Const na As UInteger = 12
        Const nb As UInteger = 7
        Const nc As UInteger = na

        Dim da() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                      137, 458365713, 637165763, 178653661, 865716386, 371657618, _
                                653165316, 531653165, 173631651, 375631865}
        Dim db() As UInteger = {MJZ_NEGATIVE, _
                                MJZ_RESERVED, _
                                716, 576176576, 756125465, 156762175, 156555154}
        Dim dc() As UInteger = New UInteger(na) {}
        Dim ac() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                     137, 458365713, 637165763, 178653661, 865716386, 371656902, _
                                76988739, 775527700, 16869476, 219076711}
        '// 時間の計測
        Dim sw As Stopwatch = New Stopwatch()
        sw.Start()

        da.CopyTo(dc, 0)

        figures = mjzCheckForFigures(da, na, 9)
        figures = mjzCheckForFigures(db, nb, 9)
        result = mjzAdd(dc, nc, db, nb)
        correct = mjzCompare(dc, na, ac, na) = 0
        sw.Stop()

        SetLabels(correct, sw, da, na, db, nb, dc, result)

    End Sub

    Private Sub buttonMultiply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonMultiply.Click
        '// 乗算
        '// ・乗算します。
        '// ・障害時は 0xffff0000 - 0xffffffff を返す。正常終了なら配列の要素数。
        '//   すなわち配列の最大要素数は 0xfffeffff である。
        '// ・配列の最後は符号を表す。１ならマイナス、０ならプラス
        '// ・乗数と被乗数の配列の要素数は異なっても構わない
        '// ・各配列の最大桁数は１０進数で９とする。すなわち最大数は 999,999,999 である。
        Dim correct As Boolean
        Dim figures As UInteger
        Dim result As UInteger

        Const na As UInteger = 12
        Const nb As UInteger = 4
        Const nc As UInteger = na + nb
        Dim da() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                123456787, 654345678, 98764321, 654, 321876543, 210099987, _
                                654328890, 346543219, 876547820, 987654321}
        Dim db() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                7, _
                                582918690}
        Dim dc() As UInteger = New UInteger(nc) {}
        Dim ac() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                936162782, 511499102, 175843635, 616064451, 669586915, 380459793, _
                                152779802, 15763158, 894653964, 446058209, 970159490}
        '// 時間の計測
        Dim sw As Stopwatch = New Stopwatch()
        sw.Start()

        figures = mjzCheckForFigures(da, na, 9)
        figures = mjzCheckForFigures(db, nb, 9)
        result = mjzMultiply(da, na, db, nb, dc, nc)
        result = mjzCheckForZero(dc, nc)
        result = mjzShiftToLeft(dc, nc, result - MJZ_NUMERICAL_POINTER)

        correct = mjzCompare(dc, result, ac, result) = 0
        sw.Stop()

        SetLabels(correct, sw, da, na, db, nb, dc, result)
    End Sub

    Private Sub buttonDivide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonDivide.Click
        '// 除算
        '// ・除算します。
        '// ・障害時は 0xffff0000 - 0xffffffff を返す。正常終了なら配列の要素数。
        '//   すなわち配列の最大要素数は 0xfffeffff である。
        '// ・配列の先頭は符号を表す。１ならマイナス、０ならプラス
        '// ・除数と被除数の配列の要素数は異なっても構わない
        '// ・各配列の最大桁数は１０進数で９とする。すなわち最大数は 999,999,999 である。
        '// ・第５引数が商、第１引数が余りとなる
        Dim correct As Boolean
        Dim result As UInteger

        Const na As UInteger = 12
        Const nb As UInteger = 5
        Const nq As UInteger = 12

        Dim da() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                76, 324089682, 448756762, 0, 0, 0, 0, 0, 0, 0}
        Dim db() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                24, 294712299, 901695663}
        Dim ac() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                0, 0, 3, 141592653, 589793238, 462643383, _
                                279502884, 134204314, 768296341, 347735847}
        Dim quotient() As UInteger = New UInteger(nq) {}
        Dim remainder() As UInteger = New UInteger(na) {}   '// Remainder = 18, 665538574, 110309818

        '// PI = 3
        '//      141592653	
        '//      589793238
        '//      462643383
        '//      279502884
        '//      197169399
        '// 時間の計測
        Dim sw As Stopwatch = New Stopwatch()
        sw.Start()

        da.CopyTo(remainder, 0)

        result = mjzDivide(remainder, na, db, nb, quotient, nq)
        correct = mjzCompare(quotient, nq, ac, nq) = 0

        sw.Stop()

        SetLabels(correct, sw, da, na, db, nb, quotient, result, remainder, na)
    End Sub

    Private Sub buttonFactorial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonFactorial.Click
        '// 階乗の計算
        '// ・スターリングの近似式　n! = n^n * e^-n * (2*n*pi)^(1/2)
        Dim correct As Boolean
        Dim result As UInteger

        Const n As Integer = 180
        Const nac As UInteger = 39

        Dim da() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                n}
        Dim db() As UInteger, dd() As UInteger, dt() As UInteger
        Dim c() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                2}
        Dim ac() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                200896, 62499134, 299656951, 336898466, 838917540, 340798867, _
                                777940435, 335160044, 860953395, 980941180, 138112097, 309735631, _
                                594101037, 399609671, 32132186, 331495273, 609598531, 966730972, _
                                945653558, 819806475, 64353856, 858157445, 40809209, 560358463, _
                                319644664, 891114256, 430017824, 141796753, 818192338, 642302693, _
                                327818731, 986039603, 200000000, 0, 0, 0, _
                                0}
        Dim figures As UInteger
        Dim size As UInteger
        '// 時間の計測
        Dim sw As Stopwatch = New Stopwatch()
        sw.Start()


        '// 桁数の予想
        '// スターリングの近似式より
        figures = (n * Math.Log10(n * 0.3678794411714) + 0.5 * Math.Log10(2.0 * Math.PI) + 1)
        size = figures / MJZ_SIGNIFICANT_FIGURES + 1 + MJZ_NUMERICAL_POINTER

        db = New UInteger(size) {}
        dd = New UInteger(size) {}
        db(size - 1) = 1

        For i As UInteger = 0 To n - 1

            result = mjzMultiply(db, size, c, 3, dd, size)

            dt = dd
            dd = db
            db = dt

            c(MJZ_NUMERICAL_POINTER) = c(MJZ_NUMERICAL_POINTER) + 1
        Next

        correct = mjzCompare(dd, result, ac, nac) = 0
        sw.Stop()

        SetLabels(correct, sw, da, 3, dd, result)
    End Sub

    Private Sub buttonLogarithm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonLogarithm.Click
        '// 対数
        '// ・logX = 1/X の面積
        '// ・積分に台形公式使用 logX = h/2 * (1/1+1/Xn+2*(1/X1+1/X2....1/Xn-1))
        Dim result As UInteger

        '// log3.1 = 1.131402111491100561911172869858
        Const n As UInteger = 12
        Const nf As UInteger = 5
        Const nh As UInteger = 5
        Const ni As UInteger = 3
        Const ns As UInteger = 24

        Dim f0() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                0, 1, 0, 0, 0, 0, 0, 0, 0, 0}
        Dim fn() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                0, 3, 100000000}
        Dim h() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                0, 0, 21000000}
        Dim s() As UInteger = New UInteger(ns) {}
        Dim s0() As UInteger = New UInteger(n) {}
        Dim s1 = New UInteger(n) {}
        Dim s2 = New UInteger(n) {}
        Dim sn = New UInteger(n) {}
        Dim ta() As UInteger = New UInteger(n) {}
        Dim tb = New UInteger(n) {}
        Dim tc = New UInteger(n) {}
        Dim i() As UInteger = New UInteger(ni) {}
        '// 時間の計測
        Dim sw As Stopwatch = New Stopwatch()
        sw.Start()

        ta(MJZ_NUMERICAL_POINTER) = 1
        result = mjzDivide(ta, n, fn, nf, s0, n)
        result = mjzAdd(s0, n, f0, n)

        tb(MJZ_NUMERICAL_POINTER + 1) = 1

        For i(MJZ_NUMERICAL_POINTER) = 1 To 99

            Array.Clear(ta, 0, n)
            Array.Clear(tc, 0, n)
            tc(MJZ_NUMERICAL_POINTER) = 1

            result = mjzMultiply(i, ni, h, nh, ta, 5)
            result = mjzAdd(ta, result, tb, result)
            result = mjzDivide(tc, n, ta, result, sn, n)
            result = mjzAdd(s1, n, sn, n)
        Next

        Array.Clear(ta, 0, n)
        Array.Clear(tb, 0, n)

        ta(n - 1) = 2
        result = mjzMultiply(s1, n, ta, n, s2, n)
        result = mjzAdd(s2, n, s0, n)
        ta(MJZ_NUMERICAL_POINTER) = 2
        result = mjzDivide(h, nh, ta, 3, tb, nh)
        result = mjzMultiply(s2, n, tb, result, s, n + 1)
        sw.Stop()

        SetLabels(True, sw, fn, nf, s, result)
    End Sub

    Private Sub buttonPower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonPower.Click
        '// 冪乗
        Const na As Integer = 32
        Dim power As Integer = 102
        Dim answer() As UInteger = New UInteger(na) {}
        Dim baseForPower() As UInteger = {MJZ_POSITIVE, _
                                            MJZ_RESERVED, 39}
        Dim p() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, power}
        Dim ac() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                        1, 943524039, 63826536, 649857299, 724357504, 709860298, _
                                384642872, 517237682, 989751006, 104182243, 343398736, 298811722, _
                                231536565, 749131513, 96597373, 810943242, 880339240, 987952031, _
                                963437521}

        Dim correct As Boolean = False
        Dim result As UInteger
        '// 時間の計測
        Dim sw As Stopwatch = New Stopwatch()
        sw.Start()


        result = mjzPower(baseForPower, 3, power, answer, na)

        If result < MJZ_MAX_SIZE_OF_ELEMENTS Then
            result = mjzShiftToLeft(answer, _
                                na, _
                                mjzCheckForZero(answer, na) - MJZ_NUMERICAL_POINTER)
            correct = mjzCompare(answer, result, ac, result) = 0
        End If

        sw.Stop()

        SetLabels(correct, sw, baseForPower, 3, p, 3, answer, result)
    End Sub

    Private Sub buttonSquareRoot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSquareRoot.Click
        '// 平方根 
        '//	・平方根を求める
        '//	・ニュートン法を使用
        '//	・y = x^2 - a より 0 = (x + a / x) / 2 を算出 
        Const n As UInteger = 12
        Const ne As UInteger = 24
        Const n2 As UInteger = 3
        Const nac As UInteger = 6

        Dim correct As Boolean
        Dim da() As UInteger = New UInteger(n) {}
        Dim dc() As UInteger = New UInteger(n) {}
        Dim dq() As UInteger = New UInteger(n) {}
        Dim de() As UInteger = New UInteger(ne) {}
        Dim result As UInteger

        '// square root of 99
        Dim initialValue() As UInteger = {9, 0}
        Dim target() As UInteger = {MJZ_POSITIVE, _
                                    MJZ_RESERVED, _
                                    99, 0, 0, 0, 0, 0, 0, 0, 0, 0}
        Dim ac() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                9, 949874371, 66199547, 344798210, 121}
        Dim errorRange() As UInteger = {MJZ_POSITIVE, _
                                        MJZ_RESERVED, _
                                        0, 0, 0, 0, 0, 999999999, _
                                        999999999, 999999999, 999999999, 999999999}
        Dim d2() As UInteger = {MJZ_POSITIVE, _
                                MJZ_RESERVED, _
                                2}
        '// 時間の計測
        Dim sw As Stopwatch = New Stopwatch()
        sw.Start()

        Array.Clear(dc, 0, dc.Length)
        initialValue.CopyTo(dc, 2)

        For i As UInteger = 0 To 9

            target.CopyTo(da, 0)

            result = mjzDivide(da, n, dc, n, dq, n)
            result = mjzRemoveZero(dq, n)
            dc.CopyTo(da, 0)
            result = mjzRemoveZero(da, n)
            result = mjzAdd(dq, n, da, n)
            result = mjzDivide(dq, n, d2, n2, dc, n)

            '// 判定
            result = mjzMultiply(dc, n, dc, n, de, ne)
            de(MJZ_SIGN_POINTER) = MJZ_NEGATIVE
            result = mjzRemoveZero(de, ne)
            result = mjzAdd(de, n, target, n)
            de(MJZ_SIGN_POINTER) = MJZ_POSITIVE

            If (mjzCompare(de, n, errorRange, n) < 0) Then
                Exit For
            End If
            result = mjzShiftToRight(dc, n, 4)
        Next

        mjzRemoveZero(dc, n)
        correct = mjzCompare(dc, nac, dc, nac) = 0
        sw.Stop()

        SetLabels(correct, sw, target, n, dc, n)
    End Sub


    Private Sub SetLabel(ByVal id As Integer, ByVal a() As UInteger, ByVal na As UInteger)

        Dim title() As String = {"A = ", "B = ", "ANSWER = ", "REMAINDER = "}
        Dim space() As String = {"        ", "        ", "                  ", "                       "}
        Dim text As String = ""
        Dim tmp0 As String = ""


        If (na = 0) Then

            text = title(id)

        Else

            For i As UInteger = 0 To na - 1

                Select Case i
                    Case MJZ_SIGN_POINTER
                        tmp0 = title(id)
                        If (na > 1) Then
                            If (a(i) = 0) Then
                                tmp0 += "+ "
                            Else
                                tmp0 += "- "
                            End If
                        End If
                    Case MJZ_RESERVED_POINTER
                        tmp0 = ""
                    Case MJZ_NUMERICAL_POINTER
                        tmp0 = String.Format("{0:d9}" + vbCr, a(i))
                    Case Else
                        tmp0 = String.Format("{0:s}{1:d9}" + vbCr, space(id), a(i))
                End Select

                text += tmp0
            Next

        End If

        Select Case id
            Case 0
                labelA.Text = text
            Case 1
                labelB.Text = text
            Case 2
                labelAnswer.Text = text
            Case 3
                labelRemainder.Text = text
        End Select

    End Sub

    Private Sub SetLabels(ByVal correct As Boolean, _
                          ByRef sw As Stopwatch, _
                          ByVal a() As UInteger, _
                          ByVal na As UInteger, _
                          ByVal c() As UInteger, _
                          ByVal nc As UInteger)

        Dim b() As UInteger = {0}
        Dim remainder() As UInteger = {0}

        labelCorrect.Text = String.Format("CORRECT = {0:d}", correct)
        labelResult.Text = String.Format("RESULT = 0x{0:x8}", nc)
        labelElapsedTime.Text = String.Format("ELAPSED TIME = {0:d}.{1:d3} seconds", _
                                              sw.Elapsed.Seconds, _
                                              sw.Elapsed.Milliseconds)

        If (nc >= MJZ_ERR_MIN_SIZE) Then
            nc = 0
        End If

        SetLabel(0, a, na)
        SetLabel(1, b, 0)
        SetLabel(2, c, nc)
        SetLabel(3, remainder, 0)
    End Sub

    Private Sub SetLabels(ByVal correct As Boolean, _
                            ByRef sw As Stopwatch, _
                            ByVal a() As UInteger, _
                            ByVal na As UInteger, _
                            ByVal b() As UInteger, _
                            ByVal nb As UInteger, _
                            ByVal c() As UInteger, _
                            ByVal nc As UInteger)
        SetLabels(correct, sw, a, na, c, nc)
        SetLabel(1, b, nb)
    End Sub

    Private Sub SetLabels(ByVal correct As Boolean, _
                            ByRef sw As Stopwatch, _
                            ByVal a() As UInteger, _
                            ByVal na As UInteger, _
                            ByVal b() As UInteger, _
                            ByVal nb As UInteger, _
                            ByVal c() As UInteger, _
                            ByVal nc As UInteger, _
                            ByVal remainder() As UInteger, _
                            ByVal nr As UInteger)

        SetLabels(correct, sw, a, na, b, nb, c, nc)

        If (nc >= MJZ_ERR_MIN_SIZE) Then
            nr = 0
        End If

        SetLabel(3, remainder, nr)

    End Sub


End Class
